libstdc++: __gnu_cxx::rope< _CharT, _Alloc > Class Template Reference

libstdc++

__gnu_cxx::rope< _CharT, _Alloc > Class Template Reference
Extensions » SGI

`#include <rope>`

## Public Types
typedef _Rope_RopeConcatenation< _CharT, _Alloc > | __C
typedef _Rope_RopeFunction< _CharT, _Alloc > | __F
typedef _Rope_RopeLeaf< _CharT, _Alloc > | __L
typedef _Rope_RopeSubstring< _CharT, _Alloc > | __S
typedef __alloc_traits< _Alloc >::template rebind< __C >::other | _CAlloc
typedef __alloc_traits< _Alloc >::template rebind< _CharT >::other | _DataAlloc
typedef __alloc_traits< _Alloc >::template rebind< __F >::other | _FAlloc
typedef __alloc_traits< _Alloc >::template rebind< __L >::other | _LAlloc
typedef __alloc_traits< _Alloc >::template rebind< __S >::other | _SAlloc
typedef _Rope_const_iterator< _CharT, _Alloc > | const_iterator
typedef const _CharT * | const_pointer
typedef _CharT | const_reference
typedef std::reverse_iterator< const_iterator > | const_reverse_iterator
typedef std::ptrdiff_t | difference_type
typedef _Rope_iterator< _CharT, _Alloc > | iterator
typedef _Rope_char_ptr_proxy< _CharT, _Alloc > | pointer
typedef _Rope_char_ref_proxy< _CharT, _Alloc > | reference
typedef std::reverse_iterator< iterator > | reverse_iterator
typedef std::size_t | size_type
typedef _CharT | value_type

## Public Member Functions
| rope (_CharT __c, const allocator_type &__a=allocator_type())
| rope (char_producer< _CharT > *__fn, size_type __len, bool __delete_fn, const allocator_type &__a=allocator_type())
| rope (const _CharT *__s, const _CharT *__e, const allocator_type &__a=allocator_type())
| rope (const _CharT *__s, const allocator_type &__a=allocator_type())
| rope (const _CharT *__s, size_type __len, const allocator_type &__a=allocator_type())
| rope (const allocator_type &__a=allocator_type())
| rope (const const_iterator &__s, const const_iterator &__e, const allocator_type &__a=allocator_type())
| rope (const iterator &__s, const iterator &__e, const allocator_type &__a=allocator_type())
| rope (const rope &__x, const allocator_type &__a=allocator_type())
| rope (size_type __n, _CharT __c, const allocator_type &__a=allocator_type())
allocator_type & | _M_get_allocator ()
const allocator_type & | _M_get_allocator () const
rope & | append ()
rope & | append (_CharT __c)
rope & | append (const _CharT *__c_string)
rope & | append (const _CharT *__iter, size_type __n)
rope & | append (const _CharT *__s, const _CharT *__e)
rope & | append (const rope &__y)
rope & | append (const_iterator __s, const_iterator __e)
rope & | append (size_type __n, _CharT __c)
void | apply_to_pieces (size_type __begin, size_type __end, _Rope_char_consumer< _CharT > &__c) const
_CharT | at (size_type __pos) const
_CharT | back () const
void | balance ()
const_iterator | begin ()
const_iterator | begin () const
const _CharT * | c_str () const
void | clear ()
int | compare (const rope &__y) const
const_iterator | const_begin () const
const_iterator | const_end () const
const_reverse_iterator | const_rbegin () const
const_reverse_iterator | const_rend () const
void | copy (_CharT *__buffer) const
size_type | copy (size_type __pos, size_type __n, _CharT *__buffer) const
void | delete_c_str ()
void | dump ()
bool | empty () const
const_iterator | end ()
const_iterator | end () const
iterator | erase (const iterator &__p)
iterator | erase (const iterator &__p, const iterator &__q)
void | erase (size_type __p, size_type __n)
size_type | find (_CharT __c, size_type __pos=0) const
size_type | find (const _CharT *__s, size_type __pos=0) const
_CharT | front () const
allocator_type | get_allocator () const
iterator | insert (const iterator &__p)
iterator | insert (const iterator &__p, _CharT __c)
iterator | insert (const iterator &__p, const _CharT *__i, const _CharT *__j)
iterator | insert (const iterator &__p, const _CharT *__i, size_type __n)
iterator | insert (const iterator &__p, const _CharT *c_string)
iterator | insert (const iterator &__p, const const_iterator &__i, const const_iterator &__j)
iterator | insert (const iterator &__p, const iterator &__i, const iterator &__j)
iterator | insert (const iterator &__p, const rope &__r)
iterator | insert (const iterator &__p, size_type __n, _CharT __c)
void | insert (size_type __p)
void | insert (size_type __p, _CharT __c)
void | insert (size_type __p, const _CharT *__c_string)
void | insert (size_type __p, const _CharT *__i, const _CharT *__j)
void | insert (size_type __p, const _CharT *__i, size_type __n)
void | insert (size_type __p, const const_iterator &__i, const const_iterator &__j)
void | insert (size_type __p, const iterator &__i, const iterator &__j)
void | insert (size_type __p, const rope &__r)
void | insert (size_type __p, size_type __n, _CharT __c)
size_type | length () const
size_type | max_size () const
iterator | mutable_begin ()
iterator | mutable_end ()
reverse_iterator | mutable_rbegin ()
reference | mutable_reference_at (size_type __pos)
reverse_iterator | mutable_rend ()
rope & | operator= (const rope &__x)
_CharT | operator[] (size_type __pos) const
void | pop_back ()
void | pop_front ()
void | push_back (_CharT __x)
void | push_front (_CharT __x)
const_reverse_iterator | rbegin ()
const_reverse_iterator | rbegin () const
const_reverse_iterator | rend ()
const_reverse_iterator | rend () const
void | replace (const iterator &__p, _CharT __c)
void | replace (const iterator &__p, const _CharT *__c_string)
void | replace (const iterator &__p, const _CharT *__i, const _CharT *__j)
void | replace (const iterator &__p, const _CharT *__i, size_type __n)
void | replace (const iterator &__p, const iterator &__q, _CharT __c)
void | replace (const iterator &__p, const iterator &__q, const _CharT *__c_string)
void | replace (const iterator &__p, const iterator &__q, const _CharT *__i, const _CharT *__j)
void | replace (const iterator &__p, const iterator &__q, const _CharT *__i, size_type __n)
void | replace (const iterator &__p, const iterator &__q, const const_iterator &__i, const const_iterator &__j)
void | replace (const iterator &__p, const iterator &__q, const iterator &__i, const iterator &__j)
void | replace (const iterator &__p, const iterator &__q, const rope &__r)
void | replace (const iterator &__p, const rope &__r)
void | replace (const iterator &__p, const_iterator __i, const_iterator __j)
void | replace (const iterator &__p, iterator __i, iterator __j)
void | replace (size_type __p, _CharT __c)
void | replace (size_type __p, const _CharT *__c_string)
void | replace (size_type __p, const _CharT *__i, const _CharT *__j)
void | replace (size_type __p, const _CharT *__i, size_type __i_len)
void | replace (size_type __p, const const_iterator &__i, const const_iterator &__j)
void | replace (size_type __p, const iterator &__i, const iterator &__j)
void | replace (size_type __p, const rope &__r)
void | replace (size_type __p, size_type __n, _CharT __c)
void | replace (size_type __p, size_type __n, const _CharT *__c_string)
void | replace (size_type __p, size_type __n, const _CharT *__i, const _CharT *__j)
void | replace (size_type __p, size_type __n, const _CharT *__i, size_type __i_len)
void | replace (size_type __p, size_type __n, const const_iterator &__i, const const_iterator &__j)
void | replace (size_type __p, size_type __n, const iterator &__i, const iterator &__j)
void | replace (size_type __p, size_type __n, const rope &__r)
const _CharT * | replace_with_c_str ()
size_type | size () const
rope< _CharT, _Alloc > | substr (const_iterator __start)
rope | substr (const_iterator __start, const_iterator __end) const
rope | substr (iterator __start) const
rope | substr (iterator __start, iterator __end) const
rope | substr (size_type __start, size_type __len=1) const
void | swap (rope &__b)

## Static Public Member Functions
static __C * | _C_allocate (std::size_t __n)
static void | _C_deallocate (__C *__p, std::size_t __n)
static _CharT * | _Data_allocate (std::size_t __n)
static void | _Data_deallocate (_CharT *__p, std::size_t __n)
static __F * | _F_allocate (std::size_t __n)
static void | _F_deallocate (__F *__p, std::size_t __n)
static __L * | _L_allocate (std::size_t __n)
static void | _L_deallocate (__L *__p, std::size_t __n)
static __S * | _S_allocate (std::size_t __n)
static void | _S_deallocate (__S *__p, std::size_t __n)

## Public Attributes
_RopeRep * | _M_tree_ptr

## Static Public Attributes
static const size_type | npos

## Protected Types
enum | { _S_copy_max }
typedef _Rope_base< _CharT, _Alloc > | _Base
typedef _CharT * | _Cstrptr
typedef _Rope_RopeConcatenation< _CharT, _Alloc > | _RopeConcatenation
typedef _Rope_RopeFunction< _CharT, _Alloc > | _RopeFunction
typedef _Rope_RopeLeaf< _CharT, _Alloc > | _RopeLeaf
typedef _Rope_RopeRep< _CharT, _Alloc > | _RopeRep
typedef _Rope_RopeSubstring< _CharT, _Alloc > | _RopeSubstring
typedef _Rope_self_destruct_ptr< _CharT, _Alloc > | _Self_destruct_ptr
typedef _Base::allocator_type | allocator_type

## Static Protected Member Functions
static size_type | _S_allocated_capacity (size_type __n)
static bool | _S_apply_to_pieces (_Rope_char_consumer< _CharT > &__c, const _RopeRep *__r, size_type __begin, size_type __end)
static _RopeRep * | _S_concat (_RopeRep *__left, _RopeRep *__right)
static _RopeRep * | _S_concat_char_iter (_RopeRep *__r, const _CharT *__iter, size_type __slen, allocator_type &__a)
static _RopeRep * | _S_destr_concat_char_iter (_RopeRep *__r, const _CharT *__iter, size_type __slen, allocator_type &__a)
static _RopeLeaf * | _S_destr_leaf_concat_char_iter (_RopeLeaf *__r, const _CharT *__iter, size_type __slen)
static _CharT | _S_fetch (_RopeRep *__r, size_type __pos)
static _CharT * | _S_fetch_ptr (_RopeRep *__r, size_type __pos)
static bool | _S_is0 (_CharT __c)
static _RopeLeaf * | _S_leaf_concat_char_iter (_RopeLeaf *__r, const _CharT *__iter, size_type __slen)
static _RopeConcatenation * | _S_new_RopeConcatenation (_RopeRep *__left, _RopeRep *__right, allocator_type &__a)
static _RopeFunction * | _S_new_RopeFunction (char_producer< _CharT > *__f, size_type __size, bool __d, allocator_type &__a)
static _RopeLeaf * | _S_new_RopeLeaf (_CharT *__s, size_type __size, allocator_type &__a)
static _RopeSubstring * | _S_new_RopeSubstring (_Rope_RopeRep< _CharT, _Alloc > *__b, size_type __s, size_type __l, allocator_type &__a)
static void | _S_ref (_RopeRep *__t)
static _RopeLeaf * | _S_RopeLeaf_from_unowned_char_ptr (const _CharT *__s, size_type __size, allocator_type &__a)
static size_type | _S_rounded_up_size (size_type __n)
static _RopeRep * | _S_substring (_RopeRep *__base, size_type __start, size_type __endp1)
static _RopeRep * | _S_tree_concat (_RopeRep *__left, _RopeRep *__right)
static void | _S_unref (_RopeRep *__t)
static _RopeRep * | replace (_RopeRep *__old, size_type __pos1, size_type __pos2, _RopeRep *__r)

## Static Protected Attributes
static _CharT | _S_empty_c_str [1]

## Friends
class | _Rope_char_ptr_proxy< _CharT, _Alloc >
class | _Rope_char_ref_proxy< _CharT, _Alloc >
class | _Rope_const_iterator< _CharT, _Alloc >
class | _Rope_iterator< _CharT, _Alloc >
class | _Rope_iterator_base< _CharT, _Alloc >
struct | _Rope_RopeRep< _CharT, _Alloc >
struct | _Rope_RopeSubstring< _CharT, _Alloc >
template<class _CharT2, class _Alloc2>
rope< _CharT2, _Alloc2 > | operator+ (const rope< _CharT2, _Alloc2 > &__left, _CharT2 __right)
template<class _CharT2, class _Alloc2>
rope< _CharT2, _Alloc2 > | operator+ (const rope< _CharT2, _Alloc2 > &__left, const _CharT2 *__right)
template<class _CharT2, class _Alloc2>
rope< _CharT2, _Alloc2 > | operator+ (const rope< _CharT2, _Alloc2 > &__left, const rope< _CharT2, _Alloc2 > &__right)

## Detailed Description

template<class _CharT, class _Alloc>
class __gnu_cxx::rope< _CharT, _Alloc >

This is an SGI extension.

Todo
  Needs documentation! See http://gcc.gnu.org/onlinedocs/libstdc++/manual/documentation_style.html

Definition at line 1552 of file rope.

## Member Typedef Documentation

## ◆ __C

template<class _CharT, class _Alloc>

typedef _Rope_RopeConcatenation<_CharT,_Alloc> __gnu_cxx::_Rope_base< _CharT, _Alloc >::__C
| inherited

Definition at line 1536 of file rope.

## ◆ __F

template<class _CharT, class _Alloc>

typedef _Rope_RopeFunction<_CharT,_Alloc> __gnu_cxx::_Rope_base< _CharT, _Alloc >::__F
| inherited

Definition at line 1536 of file rope.

## ◆ __L

template<class _CharT, class _Alloc>

typedef _Rope_RopeLeaf<_CharT,_Alloc> __gnu_cxx::_Rope_base< _CharT, _Alloc >::__L
| inherited

Definition at line 1536 of file rope.

## ◆ __S

template<class _CharT, class _Alloc>

typedef _Rope_RopeSubstring<_CharT,_Alloc> __gnu_cxx::_Rope_base< _CharT, _Alloc >::__S
| inherited

Definition at line 1536 of file rope.

## ◆ _Base

template<class _CharT, class _Alloc>

typedef _Rope_base<_CharT, _Alloc> __gnu_cxx::rope< _CharT, _Alloc >::_Base
| protected

Definition at line 1574 of file rope.

## ◆ _CAlloc

template<class _CharT, class _Alloc>

typedef __alloc_traits<_Alloc>::template rebind<__C>::other __gnu_cxx::_Rope_base< _CharT, _Alloc >::_CAlloc
| inherited

Definition at line 1536 of file rope.

## ◆ _Cstrptr

template<class _CharT, class _Alloc>

typedef _CharT* __gnu_cxx::rope< _CharT, _Alloc >::_Cstrptr
| protected

Definition at line 1579 of file rope.

## ◆ _DataAlloc

template<class _CharT, class _Alloc>

typedef __alloc_traits<_Alloc>::template rebind<_CharT>::other __gnu_cxx::_Rope_base< _CharT, _Alloc >::_DataAlloc
| inherited

Definition at line 1536 of file rope.

## ◆ _FAlloc

template<class _CharT, class _Alloc>

typedef __alloc_traits<_Alloc>::template rebind<__F>::other __gnu_cxx::_Rope_base< _CharT, _Alloc >::_FAlloc
| inherited

Definition at line 1536 of file rope.

## ◆ _LAlloc

template<class _CharT, class _Alloc>

typedef __alloc_traits<_Alloc>::template rebind<__L>::other __gnu_cxx::_Rope_base< _CharT, _Alloc >::_LAlloc
| inherited

Definition at line 1536 of file rope.

## ◆ _RopeConcatenation

template<class _CharT, class _Alloc>

typedef _Rope_RopeConcatenation<_CharT, _Alloc> __gnu_cxx::rope< _CharT, _Alloc >::_RopeConcatenation
| protected

Definition at line 1592 of file rope.

## ◆ _RopeFunction

template<class _CharT, class _Alloc>

typedef _Rope_RopeFunction<_CharT, _Alloc> __gnu_cxx::rope< _CharT, _Alloc >::_RopeFunction
| protected

Definition at line 1594 of file rope.

## ◆ _RopeLeaf

template<class _CharT, class _Alloc>

typedef _Rope_RopeLeaf<_CharT, _Alloc> __gnu_cxx::rope< _CharT, _Alloc >::_RopeLeaf
| protected

Definition at line 1593 of file rope.

## ◆ _RopeRep

template<class _CharT, class _Alloc>

typedef _Rope_RopeRep<_CharT, _Alloc> __gnu_cxx::rope< _CharT, _Alloc >::_RopeRep
| protected

Definition at line 1591 of file rope.

## ◆ _RopeSubstring

template<class _CharT, class _Alloc>

typedef _Rope_RopeSubstring<_CharT, _Alloc> __gnu_cxx::rope< _CharT, _Alloc >::_RopeSubstring
| protected

Definition at line 1595 of file rope.

## ◆ _SAlloc

template<class _CharT, class _Alloc>

typedef __alloc_traits<_Alloc>::template rebind<__S>::other __gnu_cxx::_Rope_base< _CharT, _Alloc >::_SAlloc
| inherited

Definition at line 1536 of file rope.

## ◆ _Self_destruct_ptr

template<class _CharT, class _Alloc>

typedef _Rope_self_destruct_ptr<_CharT, _Alloc> __gnu_cxx::rope< _CharT, _Alloc >::_Self_destruct_ptr
| protected

Definition at line 1634 of file rope.

## ◆ allocator_type

template<class _CharT, class _Alloc>

typedef _Base::allocator_type __gnu_cxx::rope< _CharT, _Alloc >::allocator_type
| protected

Definition at line 1575 of file rope.

## ◆ const_iterator

template<class _CharT, class _Alloc>

typedef _Rope_const_iterator<_CharT, _Alloc> __gnu_cxx::rope< _CharT, _Alloc >::const_iterator

Definition at line 1561 of file rope.

## ◆ const_pointer

template<class _CharT, class _Alloc>

typedef const _CharT* __gnu_cxx::rope< _CharT, _Alloc >::const_pointer

Definition at line 1559 of file rope.

## ◆ const_reference

template<class _CharT, class _Alloc>

typedef _CharT __gnu_cxx::rope< _CharT, _Alloc >::const_reference

Definition at line 1558 of file rope.

## ◆ const_reverse_iterator

template<class _CharT, class _Alloc>

typedef std::reverse_iterator<const_iterator> __gnu_cxx::rope< _CharT, _Alloc >::const_reverse_iterator

Definition at line 2109 of file rope.

## ◆ difference_type

template<class _CharT, class _Alloc>

typedef std::ptrdiff_t __gnu_cxx::rope< _CharT, _Alloc >::difference_type

Definition at line 1556 of file rope.

## ◆ iterator

template<class _CharT, class _Alloc>

typedef _Rope_iterator<_CharT, _Alloc> __gnu_cxx::rope< _CharT, _Alloc >::iterator

Definition at line 1560 of file rope.

## ◆ pointer

template<class _CharT, class _Alloc>

typedef _Rope_char_ptr_proxy<_CharT, _Alloc> __gnu_cxx::rope< _CharT, _Alloc >::pointer

Definition at line 1563 of file rope.

## ◆ reference

template<class _CharT, class _Alloc>

typedef _Rope_char_ref_proxy<_CharT, _Alloc> __gnu_cxx::rope< _CharT, _Alloc >::reference

Definition at line 1562 of file rope.

## ◆ reverse_iterator

template<class _CharT, class _Alloc>

typedef std::reverse_iterator<iterator> __gnu_cxx::rope< _CharT, _Alloc >::reverse_iterator

Definition at line 2640 of file rope.

## ◆ size_type

template<class _CharT, class _Alloc>

typedef std::size_t __gnu_cxx::rope< _CharT, _Alloc >::size_type

Definition at line 1557 of file rope.

## ◆ value_type

template<class _CharT, class _Alloc>

typedef _CharT __gnu_cxx::rope< _CharT, _Alloc >::value_type

Definition at line 1555 of file rope.

## Member Enumeration Documentation

## ◆ anonymous enum

template<class _CharT, class _Alloc>

anonymous enum
| protected

Definition at line 1587 of file rope.

## Constructor & Destructor Documentation

## ◆ rope() [1/10]

template<class _CharT, class _Alloc>

__gnu_cxx::rope< _CharT, _Alloc >::rope | ( | const _CharT * | __s,
|  | const allocator_type & | __a = allocator_type() )
| inline

Definition at line 1845 of file rope.

## ◆ rope() [2/10]

template<class _CharT, class _Alloc>

__gnu_cxx::rope< _CharT, _Alloc >::rope | ( | const _CharT * | __s,
|  | size_type | __len,
|  | const allocator_type & | __a = allocator_type() )
| inline

Definition at line 1853 of file rope.

## ◆ rope() [3/10]

template<class _CharT, class _Alloc>

__gnu_cxx::rope< _CharT, _Alloc >::rope | ( | const _CharT * | __s,
|  | const _CharT * | __e,
|  | const allocator_type & | __a = allocator_type() )
| inline

Definition at line 1864 of file rope.

## ◆ rope() [4/10]

template<class _CharT, class _Alloc>

__gnu_cxx::rope< _CharT, _Alloc >::rope | ( | const const_iterator & | __s,
|  | const const_iterator & | __e,
|  | const allocator_type & | __a = allocator_type() )
| inline

Definition at line 1872 of file rope.

## ◆ rope() [5/10]

template<class _CharT, class _Alloc>

__gnu_cxx::rope< _CharT, _Alloc >::rope | ( | const iterator & | __s,
|  | const iterator & | __e,
|  | const allocator_type & | __a = allocator_type() )
| inline

Definition at line 1878 of file rope.

## ◆ rope() [6/10]

template<class _CharT, class _Alloc>

__gnu_cxx::rope< _CharT, _Alloc >::rope | ( | _CharT | __c,
|  | const allocator_type & | __a = allocator_type() )
| inline

Definition at line 1884 of file rope.

## ◆ rope() [7/10]

template<class _CharT, class _Alloc>

__gnu_cxx::rope< _CharT, _Alloc >::rope | ( | size_type | __n,
|  | _CharT | __c,
|  | const allocator_type & | __a = allocator_type() )

Definition at line 1533 of file ropeimpl.h.

## ◆ rope() [8/10]

template<class _CharT, class _Alloc>

__gnu_cxx::rope< _CharT, _Alloc >::rope | ( | const allocator_type & | __a = allocator_type() | ) |
| inline

Definition at line 1906 of file rope.

## ◆ rope() [9/10]

template<class _CharT, class _Alloc>

__gnu_cxx::rope< _CharT, _Alloc >::rope | ( | char_producer< _CharT > * | __fn,
|  | size_type | __len,
|  | bool | __delete_fn,
|  | const allocator_type & | __a = allocator_type() )
| inline

Definition at line 1910 of file rope.

## ◆ rope() [10/10]

template<class _CharT, class _Alloc>

__gnu_cxx::rope< _CharT, _Alloc >::rope | ( | const rope< _CharT, _Alloc > & | __x,
|  | const allocator_type & | __a = allocator_type() )
| inline

Definition at line 1919 of file rope.

## ◆ ~rope()

template<class _CharT, class _Alloc>

__gnu_cxx::rope< _CharT, _Alloc >::~rope | ( |  | ) |
throw | ( | ) |  |  |
| inline

Definition at line 1923 of file rope.

## Member Function Documentation

## ◆ _C_allocate()

template<class _CharT, class _Alloc>

__C * __gnu_cxx::_Rope_base< _CharT, _Alloc >::_C_allocate | ( | std::size_t | __n | ) |
| inlinestaticinherited

Definition at line 1536 of file rope.

## ◆ _C_deallocate()

template<class _CharT, class _Alloc>

void __gnu_cxx::_Rope_base< _CharT, _Alloc >::_C_deallocate | ( | __C * | __p,
|  | std::size_t | __n )
| inlinestaticinherited

Definition at line 1536 of file rope.

## ◆ _Data_allocate()

template<class _CharT, class _Alloc>

_CharT * __gnu_cxx::_Rope_base< _CharT, _Alloc >::_Data_allocate | ( | std::size_t | __n | ) |
| inlinestaticinherited

Definition at line 1536 of file rope.

## ◆ _Data_deallocate()

template<class _CharT, class _Alloc>

void __gnu_cxx::_Rope_base< _CharT, _Alloc >::_Data_deallocate | ( | _CharT * | __p,
|  | std::size_t | __n )
| inlinestaticinherited

Definition at line 1536 of file rope.

## ◆ _F_allocate()

template<class _CharT, class _Alloc>

__F * __gnu_cxx::_Rope_base< _CharT, _Alloc >::_F_allocate | ( | std::size_t | __n | ) |
| inlinestaticinherited

Definition at line 1536 of file rope.

## ◆ _F_deallocate()

template<class _CharT, class _Alloc>

void __gnu_cxx::_Rope_base< _CharT, _Alloc >::_F_deallocate | ( | __F * | __p,
|  | std::size_t | __n )
| inlinestaticinherited

Definition at line 1536 of file rope.

## ◆ _L_allocate()

template<class _CharT, class _Alloc>

__L * __gnu_cxx::_Rope_base< _CharT, _Alloc >::_L_allocate | ( | std::size_t | __n | ) |
| inlinestaticinherited

Definition at line 1536 of file rope.

## ◆ _L_deallocate()

template<class _CharT, class _Alloc>

void __gnu_cxx::_Rope_base< _CharT, _Alloc >::_L_deallocate | ( | __L * | __p,
|  | std::size_t | __n )
| inlinestaticinherited

Definition at line 1536 of file rope.

## ◆ _M_get_allocator() [1/2]

template<class _CharT, class _Alloc>

allocator_type & __gnu_cxx::_Rope_base< _CharT, _Alloc >::_M_get_allocator | ( |  | ) |
| inlineinherited

Definition at line 1511 of file rope.

## ◆ _M_get_allocator() [2/2]

template<class _CharT, class _Alloc>

const allocator_type & __gnu_cxx::_Rope_base< _CharT, _Alloc >::_M_get_allocator | ( |  | ) | const
| inlineinherited

Definition at line 1515 of file rope.

## ◆ _S_allocate()

template<class _CharT, class _Alloc>

__S * __gnu_cxx::_Rope_base< _CharT, _Alloc >::_S_allocate | ( | std::size_t | __n | ) |
| inlinestaticinherited

Definition at line 1536 of file rope.

## ◆ _S_allocated_capacity()

template<class _CharT, class _Alloc>

size_type __gnu_cxx::rope< _CharT, _Alloc >::_S_allocated_capacity | ( | size_type | __n | ) |
| inlinestaticprotected

Definition at line 1679 of file rope.

## ◆ _S_apply_to_pieces()

template<class _CharT, class _Alloc>

bool __gnu_cxx::rope< _CharT, _Alloc >::_S_apply_to_pieces | ( | _Rope_char_consumer< _CharT > & | __c,
|  | const _RopeRep * | __r,
|  | size_type | __begin,
|  | size_type | __end )
| staticprotected

Definition at line 921 of file ropeimpl.h.

## ◆ _S_concat()

template<class _CharT, class _Alloc>

rope< _CharT, _Alloc >::_RopeRep * __gnu_cxx::rope< _CharT, _Alloc >::_S_concat | ( | _RopeRep * | __left,
|  | _RopeRep * | __right )
| staticprotected

Definition at line 649 of file ropeimpl.h.

## ◆ _S_concat_char_iter()

template<class _CharT, class _Alloc>

rope< _CharT, _Alloc >::_RopeRep * __gnu_cxx::rope< _CharT, _Alloc >::_S_concat_char_iter | ( | _RopeRep * | __r,
|  | const _CharT * | __iter,
|  | size_type | __slen,
|  | allocator_type & | __a )
| staticprotected

Definition at line 526 of file ropeimpl.h.

## ◆ _S_deallocate()

template<class _CharT, class _Alloc>

void __gnu_cxx::_Rope_base< _CharT, _Alloc >::_S_deallocate | ( | __S * | __p,
|  | std::size_t | __n )
| inlinestaticinherited

Definition at line 1536 of file rope.

## ◆ _S_destr_concat_char_iter()

template<class _CharT, class _Alloc>

rope< _CharT, _Alloc >::_RopeRep * __gnu_cxx::rope< _CharT, _Alloc >::_S_destr_concat_char_iter | ( | _RopeRep * | __r,
|  | const _CharT * | __iter,
|  | size_type | __slen,
|  | allocator_type & | __a )
| staticprotected

Definition at line 585 of file ropeimpl.h.

## ◆ _S_destr_leaf_concat_char_iter()

template<class _CharT, class _Alloc>

rope< _CharT, _Alloc >::_RopeLeaf * __gnu_cxx::rope< _CharT, _Alloc >::_S_destr_leaf_concat_char_iter | ( | _RopeLeaf * | __r,
|  | const _CharT * | __iter,
|  | size_type | __slen )
| staticprotected

Definition at line 453 of file ropeimpl.h.

## ◆ _S_fetch()

template<class _CharT, class _Alloc>

_CharT __gnu_cxx::rope< _CharT, _Alloc >::_S_fetch | ( | _RopeRep * | __r,
|  | size_type | __pos )
| staticprotected

Definition at line 1323 of file ropeimpl.h.

## ◆ _S_fetch_ptr()

template<class _CharT, class _Alloc>

_CharT * __gnu_cxx::rope< _CharT, _Alloc >::_S_fetch_ptr | ( | _RopeRep * | __r,
|  | size_type | __pos )
| staticprotected

Definition at line 1372 of file ropeimpl.h.

## ◆ _S_is0()

template<class _CharT, class _Alloc>

bool __gnu_cxx::rope< _CharT, _Alloc >::_S_is0 | ( | _CharT | __c | ) |
| inlinestaticprotected

Definition at line 1584 of file rope.

## ◆ _S_leaf_concat_char_iter()

template<class _CharT, class _Alloc>

rope< _CharT, _Alloc >::_RopeLeaf * __gnu_cxx::rope< _CharT, _Alloc >::_S_leaf_concat_char_iter | ( | _RopeLeaf * | __r,
|  | const _CharT * | __iter,
|  | size_type | __slen )
| staticprotected

Definition at line 423 of file ropeimpl.h.

## ◆ _S_new_RopeConcatenation()

template<class _CharT, class _Alloc>

_RopeConcatenation * __gnu_cxx::rope< _CharT, _Alloc >::_S_new_RopeConcatenation | ( | _RopeRep * | __left,
|  | _RopeRep * | __right,
|  | allocator_type & | __a )
| inlinestaticprotected

Definition at line 1699 of file rope.

## ◆ _S_new_RopeFunction()

template<class _CharT, class _Alloc>

_RopeFunction * __gnu_cxx::rope< _CharT, _Alloc >::_S_new_RopeFunction | ( | char_producer< _CharT > * | __f,
|  | size_type | __size,
|  | bool | __d,
|  | allocator_type & | __a )
| inlinestaticprotected

Definition at line 1707 of file rope.

## ◆ _S_new_RopeLeaf()

template<class _CharT, class _Alloc>

_RopeLeaf * __gnu_cxx::rope< _CharT, _Alloc >::_S_new_RopeLeaf | ( | _CharT * | __s,
|  | size_type | __size,
|  | allocator_type & | __a )
| inlinestaticprotected

Definition at line 1691 of file rope.

## ◆ _S_new_RopeSubstring()

template<class _CharT, class _Alloc>

_RopeSubstring * __gnu_cxx::rope< _CharT, _Alloc >::_S_new_RopeSubstring | ( | _Rope_RopeRep< _CharT, _Alloc > * | __b,
|  | size_type | __s,
|  | size_type | __l,
|  | allocator_type & | __a )
| inlinestaticprotected

Definition at line 1715 of file rope.

## ◆ _S_ref()

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::_S_ref | ( | _RopeRep * | __t | ) |
| inlinestaticprotected

Definition at line 1623 of file rope.

## ◆ _S_RopeLeaf_from_unowned_char_ptr()

template<class _CharT, class _Alloc>

_RopeLeaf * __gnu_cxx::rope< _CharT, _Alloc >::_S_RopeLeaf_from_unowned_char_ptr | ( | const _CharT * | __s,
|  | size_type | __size,
|  | allocator_type & | __a )
| inlinestaticprotected

Definition at line 1723 of file rope.

## ◆ _S_rounded_up_size()

template<class _CharT, class _Alloc>

size_type __gnu_cxx::rope< _CharT, _Alloc >::_S_rounded_up_size | ( | size_type | __n | ) |
| inlinestaticprotected

Definition at line 1675 of file rope.

## ◆ _S_substring()

template<class _CharT, class _Alloc>

rope< _CharT, _Alloc >::_RopeRep * __gnu_cxx::rope< _CharT, _Alloc >::_S_substring | ( | _RopeRep * | __base,
|  | size_type | __start,
|  | size_type | __endp1 )
| staticprotected

Definition at line 713 of file ropeimpl.h.

## ◆ _S_tree_concat()

template<class _CharT, class _Alloc>

rope< _CharT, _Alloc >::_RopeRep * __gnu_cxx::rope< _CharT, _Alloc >::_S_tree_concat | ( | _RopeRep * | __left,
|  | _RopeRep * | __right )
| staticprotected

Definition at line 489 of file ropeimpl.h.

## ◆ _S_unref()

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::_S_unref | ( | _RopeRep * | __t | ) |
| inlinestaticprotected

Definition at line 1619 of file rope.

## ◆ append() [1/8]

template<class _CharT, class _Alloc>

rope & __gnu_cxx::rope< _CharT, _Alloc >::append | ( |  | ) |
| inline

Definition at line 2201 of file rope.

## ◆ append() [2/8]

template<class _CharT, class _Alloc>

rope & __gnu_cxx::rope< _CharT, _Alloc >::append | ( | _CharT | __c | ) |
| inline

Definition at line 2190 of file rope.

## ◆ append() [3/8]

template<class _CharT, class _Alloc>

rope & __gnu_cxx::rope< _CharT, _Alloc >::append | ( | const _CharT * | __c_string | ) |
| inline

Definition at line 2158 of file rope.

## ◆ append() [4/8]

template<class _CharT, class _Alloc>

rope & __gnu_cxx::rope< _CharT, _Alloc >::append | ( | const _CharT * | __iter,
|  | size_type | __n )
| inline

Definition at line 2147 of file rope.

## ◆ append() [5/8]

template<class _CharT, class _Alloc>

rope & __gnu_cxx::rope< _CharT, _Alloc >::append | ( | const _CharT * | __s,
|  | const _CharT * | __e )
| inline

Definition at line 2166 of file rope.

## ◆ append() [6/8]

template<class _CharT, class _Alloc>

rope & __gnu_cxx::rope< _CharT, _Alloc >::append | ( | const rope< _CharT, _Alloc > & | __y | ) |
| inline

Definition at line 2205 of file rope.

## ◆ append() [7/8]

template<class _CharT, class _Alloc>

rope & __gnu_cxx::rope< _CharT, _Alloc >::append | ( | const_iterator | __s,
|  | const_iterator | __e )
| inline

Definition at line 2177 of file rope.

## ◆ append() [8/8]

template<class _CharT, class _Alloc>

rope & __gnu_cxx::rope< _CharT, _Alloc >::append | ( | size_type | __n,
|  | _CharT | __c )
| inline

Definition at line 2214 of file rope.

## ◆ apply_to_pieces()

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::apply_to_pieces | ( | size_type | __begin,
|  | size_type | __end,
|  | _Rope_char_consumer< _CharT > & | __c ) const
| inline

Definition at line 1668 of file rope.

## ◆ at()

template<class _CharT, class _Alloc>

_CharT __gnu_cxx::rope< _CharT, _Alloc >::at | ( | size_type | __pos | ) | const
| inline

Definition at line 2069 of file rope.

## ◆ back()

template<class _CharT, class _Alloc>

_CharT __gnu_cxx::rope< _CharT, _Alloc >::back | ( |  | ) | const
| inline

Definition at line 1963 of file rope.

## ◆ balance()

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::balance | ( |  | ) |
| inline

Definition at line 1999 of file rope.

## ◆ begin() [1/2]

template<class _CharT, class _Alloc>

const_iterator __gnu_cxx::rope< _CharT, _Alloc >::begin | ( |  | ) |
| inline

Definition at line 2704 of file rope.

## ◆ begin() [2/2]

template<class _CharT, class _Alloc>

const_iterator __gnu_cxx::rope< _CharT, _Alloc >::begin | ( |  | ) | const
| inline

Definition at line 2076 of file rope.

## ◆ c_str()

template<class _CharT, class _Alloc>

const _CharT * __gnu_cxx::rope< _CharT, _Alloc >::c_str | ( |  | ) | const

Definition at line 1616 of file ropeimpl.h.

## ◆ clear()

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::clear | ( |  | ) |
| inline

Definition at line 1937 of file rope.

## ◆ compare()

template<class _CharT, class _Alloc>

int __gnu_cxx::rope< _CharT, _Alloc >::compare | ( | const rope< _CharT, _Alloc > & | __y | ) | const
| inline

Definition at line 1842 of file rope.

## ◆ const_begin()

template<class _CharT, class _Alloc>

const_iterator __gnu_cxx::rope< _CharT, _Alloc >::const_begin | ( |  | ) | const
| inline

Definition at line 2081 of file rope.

## ◆ const_end()

template<class _CharT, class _Alloc>

const_iterator __gnu_cxx::rope< _CharT, _Alloc >::const_end | ( |  | ) | const
| inline

Definition at line 2089 of file rope.

## ◆ const_rbegin()

template<class _CharT, class _Alloc>

const_reverse_iterator __gnu_cxx::rope< _CharT, _Alloc >::const_rbegin | ( |  | ) | const
| inline

Definition at line 2116 of file rope.

## ◆ const_rend()

template<class _CharT, class _Alloc>

const_reverse_iterator __gnu_cxx::rope< _CharT, _Alloc >::const_rend | ( |  | ) | const
| inline

Definition at line 2124 of file rope.

## ◆ copy() [1/2]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::copy | ( | _CharT * | __buffer | ) | const
| inline

Definition at line 2007 of file rope.

## ◆ copy() [2/2]

template<class _CharT, class _Alloc>

size_type __gnu_cxx::rope< _CharT, _Alloc >::copy | ( | size_type | __pos,
|  | size_type | __n,
|  | _CharT * | __buffer ) const
| inline

Definition at line 2019 of file rope.

## ◆ delete_c_str()

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::delete_c_str | ( |  | ) |
| inline

Definition at line 2047 of file rope.

## ◆ dump()

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::dump | ( |  | ) |
| inline

Definition at line 2032 of file rope.

## ◆ empty()

template<class _CharT, class _Alloc>

bool __gnu_cxx::rope< _CharT, _Alloc >::empty | ( |  | ) | const
| inlinenodiscard

Definition at line 1835 of file rope.

## ◆ end() [1/2]

template<class _CharT, class _Alloc>

const_iterator __gnu_cxx::rope< _CharT, _Alloc >::end | ( |  | ) |
| inline

Definition at line 2700 of file rope.

## ◆ end() [2/2]

template<class _CharT, class _Alloc>

const_iterator __gnu_cxx::rope< _CharT, _Alloc >::end | ( |  | ) | const
| inline

Definition at line 2085 of file rope.

## ◆ erase() [1/3]

template<class _CharT, class _Alloc>

iterator __gnu_cxx::rope< _CharT, _Alloc >::erase | ( | const iterator & | __p | ) |
| inline

Definition at line 2564 of file rope.

## ◆ erase() [2/3]

template<class _CharT, class _Alloc>

iterator __gnu_cxx::rope< _CharT, _Alloc >::erase | ( | const iterator & | __p,
|  | const iterator & | __q )
| inline

Definition at line 2556 of file rope.

## ◆ erase() [3/3]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::erase | ( | size_type | __p,
|  | size_type | __n )
| inline

Definition at line 2417 of file rope.

## ◆ find() [1/2]

template<class _CharT, class _Alloc>

std::size_t __gnu_cxx::rope< _CharT, _Alloc >::find | ( | _CharT | __c,
|  | size_type | __pos = 0 ) const

Definition at line 1060 of file ropeimpl.h.

## ◆ find() [2/2]

template<class _CharT, class _Alloc>

size_type __gnu_cxx::rope< _CharT, _Alloc >::find | ( | const _CharT * | __s,
|  | size_type | __pos = 0 ) const
| inline

Definition at line 2618 of file rope.

## ◆ front()

template<class _CharT, class _Alloc>

_CharT __gnu_cxx::rope< _CharT, _Alloc >::front | ( |  | ) | const
| inline

Definition at line 1995 of file rope.

## ◆ get_allocator()

template<class _CharT, class _Alloc>

allocator_type __gnu_cxx::_Rope_base< _CharT, _Alloc >::get_allocator | ( |  | ) | const
| inlineinherited

Definition at line 1507 of file rope.

## ◆ insert() [1/18]

template<class _CharT, class _Alloc>

iterator __gnu_cxx::rope< _CharT, _Alloc >::insert | ( | const iterator & | __p | ) |
| inline

Definition at line 2447 of file rope.

## ◆ insert() [2/18]

template<class _CharT, class _Alloc>

iterator __gnu_cxx::rope< _CharT, _Alloc >::insert | ( | const iterator & | __p,
|  | _CharT | __c )
| inline

Definition at line 2440 of file rope.

## ◆ insert() [3/18]

template<class _CharT, class _Alloc>

iterator __gnu_cxx::rope< _CharT, _Alloc >::insert | ( | const iterator & | __p,
|  | const _CharT * | __i,
|  | const _CharT * | __j )
| inline

Definition at line 2468 of file rope.

## ◆ insert() [4/18]

template<class _CharT, class _Alloc>

iterator __gnu_cxx::rope< _CharT, _Alloc >::insert | ( | const iterator & | __p,
|  | const _CharT * | __i,
|  | size_type | __n )
| inline

Definition at line 2461 of file rope.

## ◆ insert() [5/18]

template<class _CharT, class _Alloc>

iterator __gnu_cxx::rope< _CharT, _Alloc >::insert | ( | const iterator & | __p,
|  | const _CharT * | c_string )
| inline

Definition at line 2454 of file rope.

## ◆ insert() [6/18]

template<class _CharT, class _Alloc>

iterator __gnu_cxx::rope< _CharT, _Alloc >::insert | ( | const iterator & | __p,
|  | const const_iterator & | __i,
|  | const const_iterator & | __j )
| inline

Definition at line 2476 of file rope.

## ◆ insert() [7/18]

template<class _CharT, class _Alloc>

iterator __gnu_cxx::rope< _CharT, _Alloc >::insert | ( | const iterator & | __p,
|  | const iterator & | __i,
|  | const iterator & | __j )
| inline

Definition at line 2484 of file rope.

## ◆ insert() [8/18]

template<class _CharT, class _Alloc>

iterator __gnu_cxx::rope< _CharT, _Alloc >::insert | ( | const iterator & | __p,
|  | const rope< _CharT, _Alloc > & | __r )
| inline

Definition at line 2427 of file rope.

## ◆ insert() [9/18]

template<class _CharT, class _Alloc>

iterator __gnu_cxx::rope< _CharT, _Alloc >::insert | ( | const iterator & | __p,
|  | size_type | __n,
|  | _CharT | __c )
| inline

Definition at line 2434 of file rope.

## ◆ insert() [10/18]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::insert | ( | size_type | __p | ) |
| inline

Definition at line 2295 of file rope.

## ◆ insert() [11/18]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::insert | ( | size_type | __p,
|  | _CharT | __c )
| inline

Definition at line 2291 of file rope.

## ◆ insert() [12/18]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::insert | ( | size_type | __p,
|  | const _CharT * | __c_string )
| inline

Definition at line 2287 of file rope.

## ◆ insert() [13/18]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::insert | ( | size_type | __p,
|  | const _CharT * | __i,
|  | const _CharT * | __j )
| inline

Definition at line 2302 of file rope.

## ◆ insert() [14/18]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::insert | ( | size_type | __p,
|  | const _CharT * | __i,
|  | size_type | __n )
| inline

Definition at line 2271 of file rope.

## ◆ insert() [15/18]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::insert | ( | size_type | __p,
|  | const const_iterator & | __i,
|  | const const_iterator & | __j )
| inline

Definition at line 2309 of file rope.

## ◆ insert() [16/18]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::insert | ( | size_type | __p,
|  | const iterator & | __i,
|  | const iterator & | __j )
| inline

Definition at line 2317 of file rope.

## ◆ insert() [17/18]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::insert | ( | size_type | __p,
|  | const rope< _CharT, _Alloc > & | __r )
| inline

Definition at line 2255 of file rope.

## ◆ insert() [18/18]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::insert | ( | size_type | __p,
|  | size_type | __n,
|  | _CharT | __c )
| inline

Definition at line 2264 of file rope.

## ◆ length()

template<class _CharT, class _Alloc>

size_type __gnu_cxx::rope< _CharT, _Alloc >::length | ( |  | ) | const
| inline

Definition at line 2097 of file rope.

## ◆ max_size()

template<class _CharT, class _Alloc>

size_type __gnu_cxx::rope< _CharT, _Alloc >::max_size | ( |  | ) | const
| inline

Definition at line 2101 of file rope.

## ◆ mutable_begin()

template<class _CharT, class _Alloc>

iterator __gnu_cxx::rope< _CharT, _Alloc >::mutable_begin | ( |  | ) |
| inline

Definition at line 2633 of file rope.

## ◆ mutable_end()

template<class _CharT, class _Alloc>

iterator __gnu_cxx::rope< _CharT, _Alloc >::mutable_end | ( |  | ) |
| inline

Definition at line 2637 of file rope.

## ◆ mutable_rbegin()

template<class _CharT, class _Alloc>

reverse_iterator __gnu_cxx::rope< _CharT, _Alloc >::mutable_rbegin | ( |  | ) |
| inline

Definition at line 2643 of file rope.

## ◆ mutable_reference_at()

template<class _CharT, class _Alloc>

reference __gnu_cxx::rope< _CharT, _Alloc >::mutable_reference_at | ( | size_type | __pos | ) |
| inline

Definition at line 2651 of file rope.

## ◆ mutable_rend()

template<class _CharT, class _Alloc>

reverse_iterator __gnu_cxx::rope< _CharT, _Alloc >::mutable_rend | ( |  | ) |
| inline

Definition at line 2647 of file rope.

## ◆ operator=()

template<class _CharT, class _Alloc>

rope & __gnu_cxx::rope< _CharT, _Alloc >::operator= | ( | const rope< _CharT, _Alloc > & | __x | ) |
| inline

Definition at line 1927 of file rope.

## ◆ operator[]()

template<class _CharT, class _Alloc>

_CharT __gnu_cxx::rope< _CharT, _Alloc >::operator[] | ( | size_type | __pos | ) | const
| inline

Definition at line 2065 of file rope.

## ◆ pop_back()

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::pop_back | ( |  | ) |
| inline

Definition at line 1954 of file rope.

## ◆ pop_front()

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::pop_front | ( |  | ) |
| inline

Definition at line 1986 of file rope.

## ◆ push_back()

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::push_back | ( | _CharT | __x | ) |
| inline

Definition at line 1944 of file rope.

## ◆ push_front()

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::push_front | ( | _CharT | __x | ) |
| inline

Definition at line 1967 of file rope.

## ◆ rbegin() [1/2]

template<class _CharT, class _Alloc>

const_reverse_iterator __gnu_cxx::rope< _CharT, _Alloc >::rbegin | ( |  | ) |
| inline

Definition at line 2712 of file rope.

## ◆ rbegin() [2/2]

template<class _CharT, class _Alloc>

const_reverse_iterator __gnu_cxx::rope< _CharT, _Alloc >::rbegin | ( |  | ) | const
| inline

Definition at line 2112 of file rope.

## ◆ rend() [1/2]

template<class _CharT, class _Alloc>

const_reverse_iterator __gnu_cxx::rope< _CharT, _Alloc >::rend | ( |  | ) |
| inline

Definition at line 2708 of file rope.

## ◆ rend() [2/2]

template<class _CharT, class _Alloc>

const_reverse_iterator __gnu_cxx::rope< _CharT, _Alloc >::rend | ( |  | ) | const
| inline

Definition at line 2120 of file rope.

## ◆ replace() [1/29]

template<class _CharT, class _Alloc>

_RopeRep * __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | _RopeRep * | __old,
|  | size_type | __pos1,
|  | size_type | __pos2,
|  | _RopeRep * | __r )
| inlinestaticprotected

Definition at line 2231 of file rope.

## ◆ replace() [2/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | const iterator & | __p,
|  | _CharT | __c )
| inline

Definition at line 2531 of file rope.

## ◆ replace() [3/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | const iterator & | __p,
|  | const _CharT * | __c_string )
| inline

Definition at line 2535 of file rope.

## ◆ replace() [4/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | const iterator & | __p,
|  | const _CharT * | __i,
|  | const _CharT * | __j )
| inline

Definition at line 2543 of file rope.

## ◆ replace() [5/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | const iterator & | __p,
|  | const _CharT * | __i,
|  | size_type | __n )
| inline

Definition at line 2539 of file rope.

## ◆ replace() [6/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | const iterator & | __p,
|  | const iterator & | __q,
|  | _CharT | __c )
| inline

Definition at line 2497 of file rope.

## ◆ replace() [7/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | const iterator & | __p,
|  | const iterator & | __q,
|  | const _CharT * | __c_string )
| inline

Definition at line 2501 of file rope.

## ◆ replace() [8/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | const iterator & | __p,
|  | const iterator & | __q,
|  | const _CharT * | __i,
|  | const _CharT * | __j )
| inline

Definition at line 2511 of file rope.

## ◆ replace() [9/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | const iterator & | __p,
|  | const iterator & | __q,
|  | const _CharT * | __i,
|  | size_type | __n )
| inline

Definition at line 2506 of file rope.

## ◆ replace() [10/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | const iterator & | __p,
|  | const iterator & | __q,
|  | const const_iterator & | __i,
|  | const const_iterator & | __j )
| inline

Definition at line 2516 of file rope.

## ◆ replace() [11/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | const iterator & | __p,
|  | const iterator & | __q,
|  | const iterator & | __i,
|  | const iterator & | __j )
| inline

Definition at line 2521 of file rope.

## ◆ replace() [12/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | const iterator & | __p,
|  | const iterator & | __q,
|  | const rope< _CharT, _Alloc > & | __r )
| inline

Definition at line 2493 of file rope.

## ◆ replace() [13/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | const iterator & | __p,
|  | const rope< _CharT, _Alloc > & | __r )
| inline

Definition at line 2527 of file rope.

## ◆ replace() [14/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | const iterator & | __p,
|  | const_iterator | __i,
|  | const_iterator | __j )
| inline

Definition at line 2547 of file rope.

## ◆ replace() [15/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | const iterator & | __p,
|  | iterator | __i,
|  | iterator | __j )
| inline

Definition at line 2551 of file rope.

## ◆ replace() [16/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | size_type | __p,
|  | _CharT | __c )
| inline

Definition at line 2383 of file rope.

## ◆ replace() [17/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | size_type | __p,
|  | const _CharT * | __c_string )
| inline

Definition at line 2398 of file rope.

## ◆ replace() [18/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | size_type | __p,
|  | const _CharT * | __i,
|  | const _CharT * | __j )
| inline

Definition at line 2402 of file rope.

## ◆ replace() [19/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | size_type | __p,
|  | const _CharT * | __i,
|  | size_type | __i_len )
| inline

Definition at line 2394 of file rope.

## ◆ replace() [20/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | size_type | __p,
|  | const const_iterator & | __i,
|  | const const_iterator & | __j )
| inline

Definition at line 2406 of file rope.

## ◆ replace() [21/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | size_type | __p,
|  | const iterator & | __i,
|  | const iterator & | __j )
| inline

Definition at line 2411 of file rope.

## ◆ replace() [22/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | size_type | __p,
|  | const rope< _CharT, _Alloc > & | __r )
| inline

Definition at line 2390 of file rope.

## ◆ replace() [23/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | size_type | __p,
|  | size_type | __n,
|  | _CharT | __c )
| inline

Definition at line 2344 of file rope.

## ◆ replace() [24/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | size_type | __p,
|  | size_type | __n,
|  | const _CharT * | __c_string )
| inline

Definition at line 2351 of file rope.

## ◆ replace() [25/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | size_type | __p,
|  | size_type | __n,
|  | const _CharT * | __i,
|  | const _CharT * | __j )
| inline

Definition at line 2358 of file rope.

## ◆ replace() [26/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | size_type | __p,
|  | size_type | __n,
|  | const _CharT * | __i,
|  | size_type | __i_len )
| inline

Definition at line 2336 of file rope.

## ◆ replace() [27/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | size_type | __p,
|  | size_type | __n,
|  | const const_iterator & | __i,
|  | const const_iterator & | __j )
| inline

Definition at line 2366 of file rope.

## ◆ replace() [28/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | size_type | __p,
|  | size_type | __n,
|  | const iterator & | __i,
|  | const iterator & | __j )
| inline

Definition at line 2374 of file rope.

## ◆ replace() [29/29]

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::replace | ( | size_type | __p,
|  | size_type | __n,
|  | const rope< _CharT, _Alloc > & | __r )
| inline

Definition at line 2327 of file rope.

## ◆ replace_with_c_str()

template<class _CharT, class _Alloc>

const _CharT * __gnu_cxx::rope< _CharT, _Alloc >::replace_with_c_str | ( |  | ) |

Definition at line 1640 of file ropeimpl.h.

## ◆ size()

template<class _CharT, class _Alloc>

size_type __gnu_cxx::rope< _CharT, _Alloc >::size | ( |  | ) | const
| inline

Definition at line 2093 of file rope.

## ◆ substr() [1/5]

template<class _CharT, class _Alloc>

rope< _CharT, _Alloc > __gnu_cxx::rope< _CharT, _Alloc >::substr | ( | const_iterator | __start | ) |
| inline

Definition at line 2606 of file rope.

## ◆ substr() [2/5]

template<class _CharT, class _Alloc>

rope __gnu_cxx::rope< _CharT, _Alloc >::substr | ( | const_iterator | __start,
|  | const_iterator | __end ) const
| inline

Definition at line 2596 of file rope.

## ◆ substr() [3/5]

template<class _CharT, class _Alloc>

rope __gnu_cxx::rope< _CharT, _Alloc >::substr | ( | iterator | __start | ) | const
| inline

Definition at line 2588 of file rope.

## ◆ substr() [4/5]

template<class _CharT, class _Alloc>

rope __gnu_cxx::rope< _CharT, _Alloc >::substr | ( | iterator | __start,
|  | iterator | __end ) const
| inline

Definition at line 2580 of file rope.

## ◆ substr() [5/5]

template<class _CharT, class _Alloc>

rope __gnu_cxx::rope< _CharT, _Alloc >::substr | ( | size_type | __start,
|  | size_type | __len = 1 ) const
| inline

Definition at line 2572 of file rope.

## ◆ swap()

template<class _CharT, class _Alloc>

void __gnu_cxx::rope< _CharT, _Alloc >::swap | ( | rope< _CharT, _Alloc > & | __b | ) |
| inline

Definition at line 2221 of file rope.

## Friends And Related Symbol Documentation

## ◆ _Rope_char_ptr_proxy< _CharT, _Alloc >

template<class _CharT, class _Alloc>

friend class _Rope_char_ptr_proxy< _CharT, _Alloc >
| friend

Definition at line 1563 of file rope.

## ◆ _Rope_char_ref_proxy< _CharT, _Alloc >

template<class _CharT, class _Alloc>

friend class _Rope_char_ref_proxy< _CharT, _Alloc >
| friend

Definition at line 1563 of file rope.

## ◆ _Rope_const_iterator< _CharT, _Alloc >

template<class _CharT, class _Alloc>

friend class _Rope_const_iterator< _CharT, _Alloc >
| friend

Definition at line 1563 of file rope.

## ◆ _Rope_iterator< _CharT, _Alloc >

template<class _CharT, class _Alloc>

friend class _Rope_iterator< _CharT, _Alloc >
| friend

Definition at line 1563 of file rope.

## ◆ _Rope_iterator_base< _CharT, _Alloc >

template<class _CharT, class _Alloc>

friend class _Rope_iterator_base< _CharT, _Alloc >
| friend

Definition at line 1563 of file rope.

## ◆ _Rope_RopeRep< _CharT, _Alloc >

template<class _CharT, class _Alloc>

friend struct _Rope_RopeRep< _CharT, _Alloc >
| friend

Definition at line 1563 of file rope.

## ◆ _Rope_RopeSubstring< _CharT, _Alloc >

template<class _CharT, class _Alloc>

friend struct _Rope_RopeSubstring< _CharT, _Alloc >
| friend

Definition at line 1563 of file rope.

## Member Data Documentation

## ◆ _M_tree_ptr

template<class _CharT, class _Alloc>

_RopeRep* __gnu_cxx::_Rope_base< _CharT, _Alloc >::_M_tree_ptr
| inherited

Definition at line 1527 of file rope.

## ◆ _S_empty_c_str

template<class _CharT, class _Alloc>

_CharT __gnu_cxx::rope< _CharT, _Alloc >::_S_empty_c_str[1]
| staticprotected

Definition at line 1581 of file rope.

## ◆ npos

template<class _CharT, class _Alloc>

const size_type __gnu_cxx::rope< _CharT, _Alloc >::npos
| static

Definition at line 2613 of file rope.

The documentation for this class was generated from the following files:

- rope
- ropeimpl.h